########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########

module Bot
  class Interfaces
    
    def smsgDefaults(args)
      args[:smsg][:parse_mode] = 'HTML'
      args[:smsg][:chat_id] = args[:mmsg][:chat_id]
    end      
    
    def kbInlineUsingCallback(args)
      args[:sess] = {}      
      args[:smsg] = {}
      args[:tmp] = {}

      smsgDefaults(args)
      
      kbInlineUsingCallbackKB(args)
      kbInlineUsingCallbackAnswer(args)
      if !  args[:run][:answer].nil?
        kbInlineUsingCallbackDeleteMessages(args)
#         args[:run][:tryMethod] = args[:run][:answer][:data] # working without explicit tryMethod
        Bot::Convey.new.tryMethodRun(args)
      end
    end
    
    
    def kbInlineUsingCallbackKB args
      args[:run][:text] = args[:run][:textWithKB]
      args[:tmp][:answer] = Bot::Atom.new.sendSimpleMessage(args)   
    end
    
    def kbInlineUsingCallbackAnswer args
      args[:tmp][:subPostfix] = 'Service_Callback_Query'
      args[:tmp][:redisChannelpostfix] = args[:tmp][:answer]['result']['message_id']
      Bot::RedisQueue.new.subGetUnsub(args)
      if !  args[:run][:answer].nil?
        args[:sess][:op] = 'answerCallbackQuery'
        args[:smsg][:callback_query_id] = args[:mmsg][:query_id]    
        args[:smsg][:text] = "#{args[:run][:textAferKBPush]} #{args[:run][:answer]['data']}"
        smsgDefaults(args)      
        Bot::BotApi.new.apiAction(args)      
      end
    end
    
    def kbInlineUsingCallbackDeleteMessages args
      args[:sess][:op] = 'deleteMessage'
      smsgDefaults(args)      
      args[:smsg][:message_id] = args[:mmsg][:message_id]
      Bot::BotApi.new.apiAction(args)
      if (args[:mmsg][:chat_context] == Naming::ChatContext.Botman or args[:mmsg][:chat_context] == Naming::ChatContext.Fullman)
        args[:smsg][:message_id] = args[:mmsg][:reply_to_message_id]
        Bot::BotApi.new.apiAction(args)
      end
    end
    
  end
end
 
