########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########

module Bot
  class ConveyMeta
    
    def  hello_private(args)
      <<~HEREDOC
      Приветствую!
      Я - своего рода, проводник по платформе прототипирования коммуникационных сред Dialog. 
      Моей задачей является рассказать о том, какие возможности для такого прототипирования предоставляет вам Dialog.
      HEREDOC
    end
    
    def runMetacommand__start_main(args)
      case args[:mmsg][:chat_context]
      when 'Private'      
        args[:run][:inline_keyboard] = [
        [{text: 'Что такое "прототипирование коммуникационных сред"', callback_data: '_что такое прототипирование'}],
#         [{text: 'Как Dialog помогает в этом?', callback_data: '_как Dialog помогает'}],
        [{text: 'С чего мне начать ', callback_data: '_с чего начать'}],
        [{text: 'Список интерфейсов', callback_data: '_интерфейсы'}],          
        ]
        
        args[:run][:textWithKB] = "Основное меню" if args[:run][:textWithKB] == false
        args[:run][:textWithKB] = hello_private(args) if args[:run][:textWithKB].nil?
        args[:run][:text_parse_mode] = 'HTML' 
        args[:run][:text_disable_web_page_preview] = 1        
        
        answer = Bot::Interfaces.new.kbInlineUsingCallback(args)     
      else      
        args[:run][:text] =  "Мы пока не добавили сценарий для команды start контекста #{args[:mmsg][:chat_context]}"
        Bot::Atom.new.sendSimpleMessage(args)                       
      end
    end     
    
    ###
    
    def  what_is_prototyping(args)
      <<~HEREDOC
        <b>"Прототипирование коммуникационных сред"</b> - \n это короткое наименование трёх параллельных движений: \n
         1) <b>Я вижу, что есть среда/группа/комьюнити</b> - то есть люди, объединённые общим интересом и имеющие определённые направление и плотность движения;
         2) <b>Я выражаю свой интерес к "совместному"</b>, а для этого я должен научиться описывать как своё и средовое движения по-отдельности, так и создать прототип этого "совместного";
         3) <b>Я понимаю, что в результате возникнет новое "совместное"</b>, и я, в силу своих способностей, должен быть способен рассказать/нарисовать/описать нашу модель коммуникации и её "прототип".
        
        Чем же отличается <b>"модель"</b> от <b>"прототипа"</b>?
        
        Вот хороший ответ:
          "<b>Model</b>:
          1. Not necessarily functional (don't need to work). 
          2. Can be to any scale (usually smaller but can also be of the original size or bigger). 
          3. Used for Display or/and [Visual] Demonstration of product. 
          4. May consist of only the exterior of the object/product it replicates. 
          5. Relatively cheap to manufacture. 

          <b>Prototype</b>:
          1. Is fully functional, but not fault-proof. 
          2. Is an actual version of the intended product. 
          3. Used for performance evaluation and further improvement of product. 
          4. Contains complete interior and exterior. 
          5. Is relatively expensive to produce. 
          6. Often used as a technology demonstrator"
      
      HEREDOC
    end
    
    def runMetacommand__what_is_prototyping(args)
      args[:run][:text_parse_mode] = 'HTML' 
      args[:run][:text] =  what_is_prototyping(args)
      Bot::Atom.new.sendSimpleMessage(args)
      args[:run][:textWithKB] = false                             
      runMetacommand__start_main(args)
    end   
    alias runMetacommand__chto_takoe_prototipirovanie runMetacommand__what_is_prototyping
    
    ###
    
    def  firstStep(args)
      <<~HEREDOC
      Начнём с того, что обозначим 5 режимов работы (<b>"контекстов"</b>):
      1) <b>Private</b> - режим общения с ботом тет-а-тет
      2) <b>Noman</b> - бот добавлен в обычную группу, права бота - как у обычного пользователя
      3) <b>Botman</b> - бот добавлен в обычную группу, права бота - администратор
      4) <b>Climan</b> - бот добавлен в специальную группу, права бота - как у обычного пользователя
      5) <b>Fullman</b> - бот добавлен в специальную группу, права бота - администратор
      
      <b>"Обычная"</b> и <b>"специальная"</b> группы отличаются тем, что обычную создана человеком, а "специальная" - машиной, т.е. специальным аккаунтом, настроенным на взаимодействие с ботом.
      Права администратора дают боту возможность управлять коллективным взаимодействием согласно прописанным сценариям.
      
      
      В добавление к стандартному символу "/", используемому перед командой боту (например, "/start"), мы ввели дополнительный символ "_" для удобства общения с Dialog-ботами - например, "_start". Так же, команды могут даны на русском языке, например "_старт".
      
      В режиме <b>'private'</b> можно писать ботам:
      Боту @DialogDemoBot - это production-демобот
      Боту @DialogDemoDevBot - это демобот для разработки и отладки
      
      В режиме <b>'Noman'</b> работает группа https://t.me/joinchat/CCfa_1HM1ORbycphoyqmMw
      В режиме <b>'Botman'</b> работает группа https://t.me/joinchat/CCfa_0ndJfLFH6f_Ec8Oig
      В режиме <b>'Fullman'</b> работает группа https://t.me/joinchat/FTAtQEdYpbxl0i46Atadgw

     Канал https://t.me/joinchat/AAAAAEwvsUuDodkHj74iJQ работает в режиме тестирования возможностей Dialog в каналах.
      HEREDOC
    end
    
    def runMetacommand__start_with(args)
      args[:run][:text_parse_mode] = 'HTML' 
      args[:run][:text] =  firstStep(args)
      Bot::Atom.new.sendSimpleMessage(args)
      args[:run][:textWithKB] = false                       
      runMetacommand__start_main(args)
    end     
    alias runMetacommand__s_chego_nachat runMetacommand__start_with
      

    
  end
end
 
