########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########
    
module Dialog
  module Background
    
    class BotApi
      include Sidekiq::Worker
      include Sidekiq::Status::Worker
      sidekiq_options queue: 'default'

      def perform(instance,args)
        batch = Sidekiq::Batch.new
        batch.on(:success, 'Dialog::Background::Callback#success')
        batch.on(:complete,'Dialog::Background::Callback#complete')

        batch.jobs do
          BotApiSend.perform_in(5.seconds.from_now,instance,args.to_h)
        end
        
      end
    end


    class Callback
      include Sidekiq::Worker
      include Sidekiq::Status::Worker
      sidekiq_options queue: 'default'

      def success(status, options)
        puts "You called a callback 'success', status: #{status}, options: #{options}"
      end
      
      def complete(status, options)
        puts "You called a callback 'complete', status: #{status}, options: #{options}"
        #if status.failures != 0
      end  
    end



    class BotApiSend
      include Sidekiq::Worker
      include Sidekiq::Status::Worker
      sidekiq_options queue: 'default'

      def perform(instance, mmsg)
        bot = DRbObject.new_with_uri("drbunix:./_data/bot/#{instance}/drb.sock")
        puts "instance: #{instance}, mmsg: #{mmsg}"
        smsg = {}
        pp bot.api.send(:getMe)
        chatId = mmsg["fqndata"]["o"]["chat"]["id"]
        pp bot.api.send(:sendMessage, {'chat_id' => chatId, 'text' => "This is the background proc, man: reply to you message from '#{DateTime.strptime(mmsg["fqndata"]["o"]["msg"]["date"].to_s, '%s')}'"}) 
      end
    end



  end
end
