########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = bash
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########
set -e 


#####
DialogBotExec() (
  systemctl --user restart dialog_redis@${BotFullname}
  systemctl --user restart dialog_bot@${BotFullname}

  case $Mode in
    'prod')
      echo "Ready!"
      systemctl --user enable dialog_redis@${BotFullname}
      systemctl --user enable dialog_bot@${BotFullname}      
    ;;
    'dev')    
      mkdir -p  /tmp/_render    

      inotifywait -r -e DELETE --format '%w %f' -m ./engine |\
      (
      while read; do
        echo "Bot restarting"
        systemctl --user restart dialog_bot@${BotFullname}
      done
      )

      systemctl --user stop dialog_bot@${BotFullname}
      systemctl --user stop dialog_redis@${BotFullname}
      ;;
  esac      
)
#####
