#!/usr/bin/bash
########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = bash
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########
set -e

## PRE - ENV ##
# . ./engine/exec.sh

if [[ -z $runInstance ]]; then
    DialogMsg="Please specify instance"
    echo $DialogMsg; select runInstance in `ls ./_env/*|grep -v tmpl|sed -e 's/.*.\///'`;  do  break ; done
    runMode=`echo $runInstance|cut -d '.' -f 2`
    runInstance=`echo $runInstance|cut -d '.' -f 1`
fi

if [[ -z $runScope ]]; then
    DialogMsg="Please specify scope"
    echo $DialogMsg; select runScope in init systemd_start console_start;  do  break ; done
    showCommand=1
fi

case $runScope in 
'console_start')
  runModes="bot tdlib check dialect" 
;;
*)
  runModes="bot tdlib bot_dev"
;;
esac

if [[ -z $runMode ]]; then
    DialogMsg="Please specify mode: "
    echo $DialogMsg; select runMode in $runModes;  do  break ; done
fi   
  
if [[ $showCommand == 1 ]]; then
  GREEN='\033[0;32m'
  NC='\033[0m' # No Color
  runCommand="runInstance=$runInstance runScope=$runScope runMode=$runMode"
  echo -e "Start using:\n${GREEN}$runCommand bash ./dialog.sh ${NC}"  
else
  export $(grep -v '^#' ./_env/$runInstance.* | xargs)
  ruby ./dialog.rb
fi

