########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########

module Dialog  
  class << self
    
    def _run(mode=false)
      args = {}
      mode == false ? mode = Dialog.config.run.mode : true
      Dialog.logger.debug "Using mode '#{mode}'"      
      case mode
      when 'check'
        _require
        jsonDriven(args, :check)
      when 'bot'
        _require
        jsonDriven(args, :prod)
        bot(args)
      when 'dialect'
        _require
        dialectDriven(args)
        jsonDriven(args, :check) 
      when 'tdlib'
        start_tdlib(args) 
      when 'background'
        start_background(args)         
      else
         Dialog.logger.error "ERROR: no such mode - '#{mode}'"
      end      
    end    
    
    
    def dialectDriven(args)
      require 'dialect_lookup'
      state = {
        dialectFolder:  Dialog.config.naming.interface, 
        myAppName:      Dialog.config.naming.app, 
        sqlite:         Dialog.config.dialect.sqlite, 
        json:           Dialog.config.dialect.json
      }
      ::Dialect::Lookup.new.run(state)
#       File.delete(Dialog.config.dialect.sqlite)
    end
    
    
    def jsonDriven(args, type)
      FileUtils.rm_rf(Dir.glob("#{Dialog.config.path.dialogRender}/code_#{type}/*.rb"))     
      args[:dialect] = {}      
      
      json = Dialog.config.dialect.json
      if File.file?(json)
        jsonLoad = Oj.load(File.read(json), symbol_keys: true)
        args[:dialect] = jsonLoad[:stages][Dialog.config.naming.interface.to_sym]
        Dialog::Dialect.run(args, type)
    
        args[:dialect] ={} 
        args[:tmp] = {}      
        Dir.glob(File.join("#{Dialog.config.path.dialogRender}/code_#{type}/**", "*.rb")).sort.each{|f| require f}
        Dialog.logger.info "Rendered bot code is ok"    
      else
        Dialog.logger.info "No JSON to render, trying to export"
        begin
          trigger_start('dialect')
        rescue
          Dialog.logger.error "Seems like no Dialect DB, exiting! Please upload valid JSON or use a valid Dialect DB"          
          exit(false)
        end
      end
    end

    
  end
end
