########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########

module Dialog  
  class << self
    
  
    def redisDBStore
      @redisDBStore ||= Redis.new(path: Dialog.config.db.redis_url, db: Dialog.config.db.redisDBStore)
    end
    
    def redisDBCache
      @redisDBCache ||= Redis.new(path: Dialog.config.db.redis_url, db: Dialog.config.db.redisDBCache)
    end    
    
    def redisDBStat
      @redisDBStat ||= Redis.new(path: Dialog.config.db.redis_url, db: Dialog.config.db.redisDBStat)
    end      
    
    def clear(args)
      args[:x] = {metamess: {}, data: {}, labels: {}, send: {}, exec: {}}
      args[:smsg] = {}
    end
    
    def directoriesMustExists
       FileUtils.mkdir_p("#{Dialog.config.path.dialogData}/#{Dialog.config.run.mode}/#{Dialog.config.naming.instance}")      
       FileUtils.mkdir_p("#{Dialog.config.path.dialogTmpfiles}")
    end
    
    def clearApi(args)
      args[:api] = {}
    end    
    
    
    def perf(perf)
      a = []
      a << "mmsg: #{perf[:metamess] - perf[:init]}s"
      if perf.has_key?(:preApiAction)
        a << "canvas: #{perf[:preApiAction] - perf[:metamess]}s"        
        a << "ApiAction in canvas: #{perf[:postApiAction] - perf[:preApiAction]}s"  
      else
        a << "canvas: #{perf[:canvas] - perf[:metamess]}s"          
      end
      a << "statistics: #{perf[:statistics] - perf[:canvas]}s" if perf.has_key?(:statistics)    
      a << "full: #{perf[:fullend] - perf[:init]}s"  
    end
    
  end
end
