########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########
module Dialog
  module Dialect
    class << self
    
      def makeARepack(args, stage)
        args[:tmp][:stages][stage].each do |runProps|         
          if runProps[:repack] == 1     
            data = args[:dialect][:perView][Dialog.config.naming.app.to_sym]
            if data.is_a?(Hash)
              data.each do |viewId, viewProps|
                send("repack_#{runProps[:name]}".to_sym, args, runProps[:name], viewId) if data[viewId][runProps[:name]].is_a?(Hash)
              end  
            end
          end    
        end
      end
      
      def dialect_repack(args)
        
        args[:tmp][:stages][:codegenConstructor].each do |runProps|        
          args[:dialect][:constructors][Dialog.config.naming.app.to_sym].each do |viewId, viewProps|      
            send("repack_constructors_#{runProps[:name]}".to_sym, args, runProps[:name], viewId)
          end        
        end      
        
        makeARepack(args, :functional)
        makeARepack(args, :data)
        
      end
      
      
    
      def makeAErb(args, type, stage)
        FileUtils.mkdir_p("#{Dialog.config.path.dialogRender}/code_#{type}/")
        
        args[:tmp][:stages][stage].each do |runProps|  
          nameSym = runProps[:name].to_sym        
          data = args[:dialect][:perView][Dialog.config.naming.app.to_sym]
          if data.is_a?(Hash)          
            data.each do |viewId, viewProps|                  
              if runProps[:erb] == 1 && data[viewId].is_a?(Hash) and data[viewId][runProps[:name]].is_a?(Hash)
                  Dialog.logger.debug "### erb - #{runProps}"
                  fullName = "#{runProps[:order]}_#{runProps[:name]}_#{viewId}"
                  fullNameSym = fullName.to_sym
                
                  tmpl = ERB.new(File.read("#{File.dirname(__FILE__)}/erb/#{stage}/#{runProps[:order]}.#{runProps[:name]}.erb")).result(binding)
                  runProps.has_key?(:erb_order) ? rname = "#{runProps[:erb_order]}_#{fullName}" : rname = fullName              
                  File.open("#{Dialog.config.path.dialogRender}/code_#{type}/#{stage}__#{rname}.rb", 'w') do |f| f.write tmpl; end   
              end
            end  
          end
        end      
      end
      
      
      def dialect_erb(args, type)
        makeAErb(args, type, :functional)
        makeAErb(args, type, :data)
      end
 
    end
  end
end
