########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########
module Dialog
  module Dialect
    class << self
    
      def dialect_codegenRun_pre(args)
        state = {stages: {}}
        state[:stages][:codegenPerView] = { 
          b: :modSendOfArchi,        
          c: :rubyPreLabeling_,
          d: :modOfElementsOfAppevent,
          
          l: :modOfElementsOfBus,
          m: :elementsInElementsArchi
        }           
      end
      
      
      def dialect_codegenRun(args, type)
        args[:tmp] = {stages: {}, x: {}}
        args[:tmp][:stages][:codegenConstructor] = [     
          {name: :DockedGroupings2AppFunctions,        order: '1', erb: 0},
          {name: :Element2ModSend,                     order: '2', erb: 0},                
          {name: :ElementsInElements,                  order: '3', erb: 0},        
        ]
        
        args[:tmp][:stages][:functional] = [
          {name: :Expect2Events,        repack: 1, erb: 1, order: '1'},
          {name: :Events2AppEvent,      repack: 0, erb: 1, order: '2.1'},
          {name: :Events2ModReceive,    repack: 1, erb: 1, order: '2.2.1'},
          {name: :ModReceive2AppEvent,  repack: 1, erb: 1, order: '2.2.2'},
          {name: :AppEvent2Elements,    repack: 0, erb: 1, order: '4.1'},
          {name: :Elements2AppEvent,    repack: 0, erb: 0, order: '4.2'},          
          {name: :Appevent2EventBus,    repack: 0, erb: 1, order: '3'},
          {name: :ElementChains,        repack: 1, erb: 1, order: '7'},
          {name: :ModElementsSpecs,     repack: 0, erb: 0, order: '6'},          
          {name: :Element2ModElements,  repack: 1, erb: 1, order: '5.1'},
          {name: :Element2ModSend,      repack: 1, erb: 1, order: '5.2'},
          
          
        ]
        
        args[:tmp][:stages][:data] = [
          {name: :ModReceive2GetData,   repack: 0, erb: 1, order: '1'},
          {name: :GetData2Elements,     repack: 0, erb: 1, order: '2'},
          {name: :GenData2Dest,         repack: 0, erb: 1, order: '3'},        
        ]
        
        args[:tmp][:stages][:codegenGlobal] = {        
          n: :rubySrcLabeling
        }      
        

        dialect_repack(args)
        dialect_erb(args, type)
      end    
      
      
      def run(args, type)
        dialect_codegenRun(args,type) 
      end    
      
      def lookupDebug(name, prop)
        Dialog.logger.debug "### #{name} :: F:: '#{prop[:fName]}' fqn:#{prop[:fFqn]} o:#{prop[:fOID]} e:#{prop[:fEID]} p '#{prop[:fProp]}' :: T :: '#{prop[:tName]}' fqn:#{prop[:tFqn]} o:#{prop[:tOID]} e:#{prop[:tEID]} p '#{prop[:tProp]}'"
      end    
    
    end
  end
end
