########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########

module Dialog
  module Metamess
    class << self
    
      
      def init(args)
        args[:mmsg] = {actions: [], actionsd: {}, fqn: {}, fqndata: {}, fqnrun: {}}
        nestedHash = lambda {|h,k| h[k] = Hash.new(&nestedHash)}
        args[:rmsgcheck] = Hash.new  
        args[:metacheck] = Hash.new(&nestedHash)        
      end
      
      def rmsgcheckForm(args, k1, v1, k2=true, v2=true)
        vNext = true
        v2 == true ? value = v1 : value = v2
        value.kind_of?(Array) ? vNext = value.empty? : vNext = value.nil?   
       
#         Dialog.logger.debug "### k2 - #{k2}, value - #{value}, vNext - #{vNext}"            
        if v2 == true
          args[:rmsgcheck][k1.to_sym] = 1 if vNext == false        
        else
          args[:rmsgcheck][k1.to_sym][k2.to_sym] = 1 if vNext == false     
        end
      end
      
      
      def firstpoint(args)
        Dialog.clear(args)
  #       args[:mmsg] = Concurrent::Hash.new
        init(args)
        fqnrun = {}
        
        fqnrun[:c] =  Dialog::Naming::Class.Event
        case args[:rmsg].class.to_s
        when 'Telegram::Bot::Types::InlineQuery'
          fqnrun[:o] = Dialog::Naming::Class::Event::Order.Service
          fqnrun[:f] = Dialog::Naming::Class::Event::Order::Service::Family.Inline
          fqnrun[:g] = Dialog::Naming::Class::Event::Order::Service::Family::Inline::Genus.Query
          
        when 'Telegram::Bot::Types::ChosenInlineResult'
          fqnrun[:o] = Dialog::Naming::Class::Event::Order.Service
          fqnrun[:f] = Dialog::Naming::Class::Event::Order::Service::Family.Inline
          fqnrun[:g] = Dialog::Naming::Class::Event::Order::Service::Family::Inline::Genus.Cresult
          
        when 'Telegram::Bot::Types::CallbackQuery'
          fqnrun[:o] = Dialog::Naming::Class::Event::Order.Service
          fqnrun[:f] = Dialog::Naming::Class::Event::Order::Service::Family.Callback
          fqnrun[:g] = Dialog::Naming::Class::Event::Order::Service::Family::Callback::Genus.Query
        when 'Telegram::Bot::Types::Message'
          message_identificate(args,fqnrun)
        end
        collect(args,fqnrun)
        Dialog.logger.info("## RESULT of Metamess: #{args[:mmsg]}\n")  
        
        ##needs refactor to lambda
        args[:rmsg].to_h.each do |k1, v1|
          unless ['NilClass', 'Array', 'Integer', 'String'].include?(v1.class.to_s)
            v1.to_h.each do |k2, v2|
              args[:rmsgcheck][k1.to_sym] ||= {}    
              rmsgcheckForm(args, k1, v1, k2, v2)
            end
          else
            rmsgcheckForm(args, k1, v1)
          end
        end
        ##
#         Dialog.logger.debug("################## rmsgcheck - #{args[:rmsgcheck]}")
#         Dialog.logger.debug("################## metacheck - #{args[:metacheck]}")
        diff = args[:rmsgcheck].diff(args[:metacheck])
        unless diff == {}
          Dialog.logger.error("@@@@ !!!! Metacheck diff: #{diff}")
          Dialog.logger.info "RAW MSG:\n#{args[:rmsg].to_hash}\n"                        
        end
        args[:metacheck] = {}
        args[:rmsg] = {}
        args[:perf][:metamess] = Time.now                                
        Dialog::Canvas.run(args)
        args[:perf][:canvas] = Time.now                                
      end   
      

      def message_identificate(args,fqnrun) 
        rmsg= args[:rmsg]
        if    rmsg.respond_to?(:new_chat_members)  && !rmsg.new_chat_members.empty? ||
              rmsg.respond_to?(:left_chat_member)  && !rmsg.left_chat_member.nil?
                fqnrun[:o] = Dialog::Naming::Class::Event::Order.Notify
                fqnrun[:f] = Dialog::Naming::Class::Event::Order::Notify::Family.ChatMember
        elsif rmsg.respond_to?(:new_chat_photo)    && !rmsg.new_chat_photo.empty? ||
              rmsg.respond_to?(:delete_chat_photo) && !rmsg.delete_chat_photo.nil?
                fqnrun[:o] = Dialog::Naming::Class::Event::Order.Notify
                fqnrun[:f] = Dialog::Naming::Class::Event::Order::Notify::Family.ChatPhoto
        elsif rmsg.respond_to?(:new_chat_title)    && !rmsg.new_chat_title.nil?
                fqnrun[:o] = Dialog::Naming::Class::Event::Order.Notify
                fqnrun[:f] = Dialog::Naming::Class::Event::Order::Notify::Family.ChatTitle              
        elsif rmsg.respond_to?(:group_chat_created)&& !rmsg.group_chat_created.nil? ||
              rmsg.respond_to?(:supergroup_chat_created)&& !rmsg.supergroup_chat_created.nil?
              rmsg.respond_to?(:channel_chat_created)   && !rmsg.channel_chat_created.nil?        
                fqnrun[:o] = Dialog::Naming::Class::Event::Order.Notify
                fqnrun[:f] = Dialog::Naming::Class::Event::Order::Notify::Family.Create
        elsif rmsg.respond_to?(:migrate_to_chat_id)&& !rmsg.migrate_to_chat_id.nil? ||
              rmsg.respond_to?(:migrate_from_chat_id)   && !rmsg.migrate_from_chat_id.nil?
                fqnrun[:o] = Dialog::Naming::Class::Event::Order.Notify
                fqnrun[:f] = Dialog::Naming::Class::Event::Order::Notify::Family.Migrate
        elsif rmsg.respond_to?(:pinned_message)    && !rmsg.pinned_message.nil?
                fqnrun[:o] = Dialog::Naming::Class::Event::Order.Notify
                fqnrun[:f] = Dialog::Naming::Class::Event::Order::Notify::Family.Pinned
        elsif rmsg.respond_to?(:connected_website)    && !rmsg.connected_website.nil?
                fqnrun[:o] = Dialog::Naming::Class::Event::Order.Notify
                fqnrun[:f] = Dialog::Naming::Class::Event::Order::Notify::Family.Login
        elsif rmsg.respond_to?(:passport_data)    && !rmsg.passport_data.nil?
                fqnrun[:o] = Dialog::Naming::Class::Event::Order.Notify
                fqnrun[:f] = Dialog::Naming::Class::Event::Order::Notify::Family.Passport    
        else
              fqnrun[:o] = Dialog::Naming::Class::Event::Order.Content
        end
      end
      

      def collect(args,fqnrun)
        until fqnrun.nil?
          fqn = args[:mmsg][:fqn]
#           Dialog.logger.debug "RUN Metamess - collect: #{fqnrun}"          
          
          if fqnrun.key?(:g) && !fqnrun.key?(:f) && !fqnrun.key?(:o) && !fqnrun.key?(:c)
            run = "#{fqn[:c].to_s.capitalize}#{fqn[:o].to_s.capitalize}#{fqn[:f].to_s.capitalize}#{fqnrun[:g].to_s.capitalize}" 
          elsif fqnrun.key?(:f) && !fqnrun.key?(:o) && !fqnrun.key?(:c)
            run = "#{fqn[:c].to_s.capitalize}#{fqn[:o].to_s.capitalize}#{fqnrun[:f].to_s.capitalize}" 
          elsif fqnrun.key?(:o) && !fqnrun.key?(:c)
            run = "#{fqn[:c].to_s.capitalize}#{fqnrun[:o].to_s.capitalize}"
          elsif fqnrun.key?(:c)
            run = "#{fqnrun[:c].to_s.capitalize}"          
          else
            Dialog.logger.error "LOST MESSAGE!! "          
            raise 'LostMessage'
          end     
        
          run = "collect_#{run}"
#           Dialog.logger.debug "RUN Metamess - begin: #{run}"
          Dialog.clear(args)
          args[:mmsg][:fqnrun] = fqnrun
          send(run.to_sym, args)
          fqnrun = args[:mmsg][:fqnrun]
          Dialog.clear(args)
#           Dialog.logger.debug "RUN Metamess - end: #{run}"
        end  
      end 
      
      
    end
  end
end
