########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########
module Dialog
  module Metamess
    class << self

      def collect_EventContentMedia(args)
        metaStep(args, __method__.to_s)
        ### BODY
        metamessGen(args,eval2mmsg = { 
          :to           => {t1: '[:fqndata][:f]'},
          :fFieldsOpt   => {v1: :caption},
        })        
        ### EOF BODY
        return final(args)
      end
      
      
      def defaults_media(eval2mmsg)
        eval2mmsg = { 
          :to           => {t1: '[:fqndata][:f][:file]'},
          :fFields      => {v1: :file_id, v2: :file_size},
          :tFields      => {v1: :id, v2: :size},
          :fFieldsOpt   => {v1: :mime_type},
        }
        return eval2mmsg
      end
      
      def defaults_mediaWithDuration(eval2mmsg)
        eval2mmsg = { 
          :to           => {t1: '[:fqndata][:f][:file]'},
          :fFieldsOpt   => {v1: :duration},
        }
        return eval2mmsg
      end      
        
      
      def collect_EventContentMediaPhoto(args)
        metaStep(args, __method__.to_s)
        ### BODY
        #args[:rmsg].photo[-1].file_size ## TODO - for array
        eval2mmsg = defaults_media(eval2mmsg)
        eval2mmsg[:from]  = {f1: '[:photo][-1]'}
        metamessGen(args,eval2mmsg)  
        
        args[:mmsg][:fqndata][:f][:file][:path] = Dialog::Wrappers.apiGetFilePath(args[:mmsg][:fqndata][:f][:file][:id])      
        ### EOF BODY
        return final(args)
      end  
      
      def collect_EventContentMediaDocument(args)
        metaStep(args, __method__.to_s)
        ### BODY
        eval2mmsg = defaults_media(eval2mmsg)
        eval2mmsg[:from]  = {f1: '[:document]'}
        metamessGen(args,eval2mmsg) 
        
        metamessGen(args,eval2mmsg = { 
          :from         => {f1: '[:document]'},
          :to           => {t1: '[:fqndata][:f][:file]'},
          :fFields      => {v1: :file_name},
          :fFieldsOpt   => {v1: :name},
        })
        
        args[:mmsg][:fqndata][:f][:file][:path] = Dialog::Wrappers.apiGetFilePath(args[:mmsg][:fqndata][:f][:file][:id])      
        ### EOF BODY
        return final(args)
      end     
      
      def collect_EventContentMediatVoice(args)
        metaStep(args, __method__.to_s)
        ### BODY
        eval2mmsg = defaults_media(eval2mmsg)
        eval2mmsg[:from]  = {f1: '[:tvoice]'}
        metamessGen(args,eval2mmsg) 
        ### EOF BODY
        return final(args)
      end     

      def collect_EventContentMediaAudio(args)
        metaStep(args, __method__.to_s)
        ###
        from  = {f1: '[:audio]'}        
        eval2mmsg = defaults_media(eval2mmsg)
        eval2mmsg[:from] = from              
        metamessGen(args,eval2mmsg) 
        eval2mmsg = defaults_mediaWithDuration(eval2mmsg)
        eval2mmsg[:from] = from      
        metamessGen(args,eval2mmsg)        
        ### EOF BODY
        return final(args)
      end  
      
      def collect_EventContentMediaVideo(args)
        metaStep(args, __method__.to_s)
        ### BODY
        eval2mmsg = defaults_media(eval2mmsg)
        eval2mmsg[:from]  = {f1: '[:video]'}
        metamessGen(args,eval2mmsg)       
        ### EOF BODY
        return final(args)
      end  

      def collect_EventContentMediaVideo_note(args)
        metaStep(args, __method__.to_s)
        ### BODY
        eval2mmsg = defaults_media(eval2mmsg)
        eval2mmsg[:from]  = {f1: '[:video_note]'}
        metamessGen(args,eval2mmsg) 
        ### EOF BODY
        return final(args)
      end      
      
      def collect_EventContentMediaVoice(args)
        metaStep(args, __method__.to_s)
        ### BODY
        from  = {f1: '[:voice]'}        
        eval2mmsg = defaults_media(eval2mmsg)
        eval2mmsg[:from] = from
        metamessGen(args,eval2mmsg) 
        eval2mmsg = defaults_mediaWithDuration(eval2mmsg)
        eval2mmsg[:from] = from      
        metamessGen(args,eval2mmsg)
        ### EOF BODY
        return final(args)
      end  
      
      def collect_EventContentMediaSticker(args)
        metaStep(args, __method__.to_s)
        ### BODY
        eval2mmsg = defaults_media(eval2mmsg)
        eval2mmsg[:from]  = {f1: '[:sticker]'}
        metamessGen(args,eval2mmsg)       
        ### EOF BODY
        return final(args)
      end      
    
    end
  end
end
