########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########
module Dialog
  module Metamess
    class << self
    
      def collect_EventContent(args)
        metaStep(args, __method__.to_s)
        ### BODY

        ### Message
        content_message(args)
        ### User
        content_user(args) unless args[:rmsg][:chat][:type] == 'channel'
        ### Chat
        content_chat(args) 
        ### Chat - private
        content_chat_private(args) if args[:rmsg][:chat][:type] == 'private'    
        ### Chat - group
        content_chat_adv(args) unless args[:rmsg][:chat][:type] == 'private'
        ### Channel
        content_channel(args) if args[:rmsg][:chat][:type] == 'channel' 
        
        ### Reply
        content_reply(args)   unless args[:rmsg][:reply_to_message].nil?
        ### Forward
        content_forward(args) unless args[:rmsg][:forward_date].nil?
        ### Edit
        content_edit(args)    unless args[:rmsg][:edit_date].nil?
        
        getChatContext(args)
        content_getFQN(args)
        
        ### EOF BODY
        return final(args)
      end
      
      ### Content methods
      def content_getFQNMedia(args)
        args[:mmsg][:fqnrun][:g] = Dialog::Naming::Class::Event::Order::Content::Family::Media::Genus.Photo if args[:rmsg].respond_to?(:photo)           && !args[:rmsg].photo.empty?
        args[:mmsg][:fqnrun][:g] = Dialog::Naming::Class::Event::Order::Content::Family::Media::Genus.Document if args[:rmsg].respond_to?(:document)     && !args[:rmsg].document.nil?
        args[:mmsg][:fqnrun][:g] = Dialog::Naming::Class::Event::Order::Content::Family::Media::Genus.Voice if args[:rmsg].respond_to?(:voice)           && !args[:rmsg].voice.nil?
        args[:mmsg][:fqnrun][:g] = Dialog::Naming::Class::Event::Order::Content::Family::Media::Genus.Audio if args[:rmsg].respond_to?(:audio)           && !args[:rmsg].audio.nil?
        args[:mmsg][:fqnrun][:g] = Dialog::Naming::Class::Event::Order::Content::Family::Media::Genus.Video if args[:rmsg].respond_to?(:video)           && !args[:rmsg].video.nil?
        args[:mmsg][:fqnrun][:g] = Dialog::Naming::Class::Event::Order::Content::Family::Media::Genus.Videonote if args[:rmsg].respond_to?(:video_note) && !args[:rmsg].video_note.nil?
        args[:mmsg][:fqnrun][:g] = Dialog::Naming::Class::Event::Order::Content::Family::Media::Genus.Sticker if args[:rmsg].respond_to?(:sticker)       && !args[:rmsg].sticker.nil?   
        
        args[:mmsg][:fqnrun][:f] = Dialog::Naming::Class::Event::Order::Content::Family.Media unless args[:mmsg][:fqnrun][:g].nil?
      end
      
      def content_getFQN(args)    
        content_getFQNMedia(args)
        
        if args[:mmsg][:fqnrun][:f].nil?
          if args[:rmsg].respond_to?(:contact)   && !args[:rmsg].contact.nil?
                  args[:mmsg][:fqnrun][:f] = Dialog::Naming::Class::Event::Order::Content::Family.Contact
          elsif args[:rmsg].respond_to?(:location)  && !args[:rmsg].location.nil?
                  args[:mmsg][:fqnrun][:f] = Dialog::Naming::Class::Event::Order::Content::Family.Location
          elsif args[:rmsg].respond_to?(:invoice)   && !args[:rmsg].invoice.nil?
                  args[:mmsg][:fqnrun][:f] = Dialog::Naming::Class::Event::Order::Content::Family.Invoice
          end
        end
          
        if args[:mmsg][:fqnrun][:f].nil?
          if args[:mmsg][:fqndata][:o][:msg].key?(:textStartWith)
            case args[:mmsg][:fqndata][:o][:msg][:textStartWith]
            when ->(s) { (s.size < 70  and ((s[0] == '_') or (s[0] == '/'))) }
              args[:mmsg][:fqnrun][:f] = Dialog::Naming::Class::Event::Order::Content::Family.Command
            else
              args[:mmsg][:fqnrun][:f] = Dialog::Naming::Class::Event::Order::Content::Family.Simple
            end
          else
            args[:mmsg][:fqnrun][:f] = Dialog::Naming::Class::Event::Order::Content::Family.Notext
          end
        end
        
      end
      
      def getChatContext(args)
        case args[:mmsg][:fqndata][:o][:chat][:type]
        when 'private'
          context = Naming::ChatContext.Private
        when 'group'    
          leaveGroup(args)          
        when 'supergroup'
          context = Dialog::Storage::Redis.pullCached({ :type => 'chat', :key => 'context'}, args)
        end
        
        context.nil? ? nodata(args: args, from: 'context') : args[:mmsg][:fqndata][:o][:chat][:context] = context             
      end    
      
      ### Message
      def content_messageDefaults(args)
        args[:x][:metamess][:messageDefaults_fFields]  = {v1: :message_id, v2: :date}
        args[:x][:metamess][:messageDefaults_tFields]  = {v1: :id, v2: :date}
      end
      
      def content_messageDefaultsGet(args)
        metamessGen(args,eval2mmsg = { 
          :to           => {t1: '[:fqndata][:o][:msg]'},
          :fFields      => args[:x][:metamess][:messageDefaults_fFields],
          :tFields      => args[:x][:metamess][:messageDefaults_tFields],
          :fFieldsOpt   => {v1: :text}                               
        })
      end
      
      def content_message(args)
        content_messageDefaults(args)      
        content_messageDefaultsGet(args)
        
        args[:mmsg][:fqndata][:o][:msg][:msgtype] =  Dialog::Naming::Class::Event::Order::Content::Type.Original
        args[:rmsg].text.nil? ? true : args[:mmsg][:fqndata][:o][:msg][:textStartWith] = args[:rmsg].text.split[0..10].join(' ')           
      end       
          
      
      ### User
      def content_userDefaults(args)
        args[:x][:metamess][:userDefaults_fFields]    = {v1: :id, v2: :first_name, v3: :username, v4: :is_bot}
        args[:x][:metamess][:userDefaults_fFieldsOpt] = {v1: :last_name, v2: :language_code}
      end
      
      def content_user(args)
        content_userDefaults(args)      

        metamessGen(args,eval2mmsg = { 
          :from         => {f1: '[:from]'},                
          :to           => {t1: '[:fqndata][:o][:from]'},
          :fFields      => args[:x][:metamess][:userDefaults_fFields],
          :fFieldsOpt   => args[:x][:metamess][:userDefaults_fFieldsOpt],
        })        
      end     
      
      ### Chat
      def content_chatDefaults(args)
        args[:x][:metamess][:chatDefaults_fFields]  = {v1: :id, v2: :type}
      end    

      def content_chat(args)
        content_chatDefaults(args)      
        metamessGen(args,eval2mmsg = { 
          :from         => {f1: '[:chat]'},               
          :to           => {t1: '[:fqndata][:o][:chat]'},
          :fFields      => args[:x][:metamess][:chatDefaults_fFields],
        })         
      end     
      
      ### Chat - private
      def content_chat_private(args)              
        metamessGen(args,eval2mmsg = { 
          :from         => {f1: '[:chat]'},                
          :to           => {t1: '[:fqndata][:o][:chat]'},
          :fFields      => {v1: :first_name, v2: :last_name, v3: :username},
        })             
      end      
  

      def content_chat_adv(args)      
        metamessGen(args,eval2mmsg = { 
          :from         => {f1: '[:chat]'},               
          :to           => {t1: '[:fqndata][:o][:chat]'},
          :fFields      => {v1: :title},
          :fFieldsOpt   => {v1: :pinned_message, v2: :invite_link, v3: :username},     
          :tFieldsOpt   => {v1: :pinned_message, v2: :invitelink_name, v3: :chatlink_name},                                                                            
        })         
      end       
      
      def content_channel(args)      
        metamessGen(args,eval2mmsg = { 
          :to           => {t1: '[:fqndata][:o][:from]'},
          :fFieldsOpt   => {v1: :author_signature},                                      
        })           
      end       
      
      
      def content_reply(args)
        args[:mmsg][:fqndata][:o][:msg][:msgtype] =  Dialog::Naming::Class::Event::Order::Content::Type.Reply
        args[:mmsg][:actions] << args[:mmsg][:fqndata][:o][:msg][:msgtype]     
        
        #callback
        args[:rmsgMain] = Hash.new.merge(args[:rmsg])
        args[:rmsg] = args[:rmsg][:reply_to_message]
        args[:mmsgMain] = Hash.new.merge(args[:mmsg])
        args[:mmsg] = {}; init(args); args[:mmsgCallback] = Dialog::Metamess.collect_EventContent(args)
        args[:mmsg] = args[:mmsgMain]; args.delete(:mmsgMain)
        args[:rmsg] = args[:rmsgMain]; args.delete(:rmsgMain)
        args[:mmsg][:actionsd][:reply] = args[:mmsgCallback]; args.delete(:mmsgCallback)
        
      end

      

      def content_forward(args)
        args[:mmsg][:fqndata][:o][:msg][:msgtype] =  Dialog::Naming::Class::Event::Order::Content::Type.Forward
        args[:mmsg][:actions] << args[:mmsg][:fqndata][:o][:msg][:msgtype]
        args[:mmsg][:actionsd][:forward] = {}
        #forward_signature
        
        content_userDefaults(args)      
        metamessGen(args,eval2mmsg = { 
          :from         => {f1: '[:forward_from]'},                                      
          :to           => {t1: '[:actionsd]'},
          :fFields      => args[:x][:metamess][:userDefaults_fFields],
          :fFieldsOpt   => args[:x][:metamess][:userDefaults_fFieldsOpt],                                      
        })        

 
        metamessGen(args,eval2mmsg = { 
          :to           => {t1: '[:actionsd][:forward][:msg]'},
          :fFields      => {v1: :forward_date},
          :tFields      => {v1: :date},                                      
          :fFieldsOpt   => {v1: :forward_from_message_id},
          :tFieldsOpt   => {v1: :id},                                      
        })        

        metamessGen(args,eval2mmsg = { 
          :to           => {t1: '[:actionsd][:forward][:chat]'},
          :fFieldsOpt      => {v1: :forward_from_chat},
          :tFieldsOpt      => {v1: :id},
        })        
              
      end
      
      def content_edit(args)
        args[:mmsg][:actionsd][:edit] = {}          
        args[:mmsg][:fqndata][:o][:msg][:msgtype] =  Dialog::Naming::Class::Event::Order::Content::Type.Edit
        args[:mmsg][:actions] << args[:mmsg][:fqndata][:o][:msg][:msgtype]  

        metamessGen(args,eval2mmsg = { 
          :to           => {t1: '[:actionsd][:edit]'},
          :fFields      => {v1: :edit_date},
          :tFields      => {v1: :date},
        })
      end    
      
    end
  end
end
