########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########

module Dialog
  module Metamess
    class << self
      
      ALL_CAPS = ('A'..'Z').to_a.join
      
      def getStep(method)
        step = {}
        case method.count(ALL_CAPS)
        when 1
          step[:prev] = false
          step[:curr] = :c
          step[:next] = :o
        when 2
          step[:prev] = :c
          step[:curr] = :o
          step[:next] = :f
        when 3
          step[:prev] = :o
          step[:curr] = :f
          step[:next] = :g
        when 4
          step[:prev] = :g
          step[:curr] = :g
          step[:next] = true         
        end
        return step
      end
      
      def nodata(args: , from: )
        args[:x][:metamess][:nodata] = "### NO DATA FROM METAMESS RUNNER: Order '#{args[:x][:metamess][:o]}', method '#{args[:x][:metamess][:m]}' from '#{from}' ###"
        Dialog.logger.error "#{args[:x][:metamess][:nodata]}"
        raise TypeError
      end    
      
      def metamessGen(args,eval2mmsg)
        toPrefix = 'args[:mmsg]'
        ## BUG !!!! EVAL!!! - migrate to instance_variable_set
        eval2mmsg[:to].each do |num, val|
          begin
  #           Dialog.logger.debug "### checking hash: #{val}" 
            val = "#{toPrefix}#{val}"
            eval("#{val}.length")        
          rescue NoMethodError => @e        
  #           Dialog.logger.debug "### create hash: #{val}"        
            eval("#{val} = {}")
          end
        end
        
        eval2mmsg[:map] = eval2mmsg_simplemap(eval2mmsg) unless eval2mmsg.has_key?(:map)
        
        eval2mmsg[:map].each do |mapType, mapTypeData|
          mapTypeData.each do |pk, pv|  pk[1..-1]
            if mapType.to_s == 'opt'
              tFields = 'tFieldsOpt'; fFields = 'fFieldsOpt'; opt = true
#               Dialog.logger.debug "### 1 type: #{mapType}, tFields: #{tFields}, res: #{eval("#{eval2mmsg["#{tFields}".to_sym]}")}"
            else
              tFields = 'tFields'; fFields = 'fFields'; opt = false   
#               Dialog.logger.debug "### 2 type: #{mapType}, tFields: #{tFields}, res: #{eval("#{eval2mmsg["#{tFields}".to_sym]}")}"                    
            end
            
            to = "#{toPrefix}#{eval2mmsg[:to][pv[:to].to_sym]}#{[eval2mmsg["#{tFields}".to_sym]["v#{pk[1..-1]}".to_sym]]}"
            if eval2mmsg.has_key?(:from)
              from = "#{eval2mmsg[:from][pv[:from].to_sym]}#{[eval2mmsg["#{fFields}".to_sym]["v#{pk[1..-1]}".to_sym]]}"
            else
              from = "#{[eval2mmsg["#{fFields}".to_sym]["v#{pk[1..-1]}".to_sym]]}"
            end
            
            ## refactor to lambda
            if opt == true 
              begin
                eval("args[:rmsg]#{from}.nil?") ? metacheck = false : metacheck = "args[:metacheck]#{from}" 
              rescue NoMethodError => @e    
                 metacheck = false
              end
            else
              metacheck = "args[:metacheck]#{from}" 
            end
#             Dialog.logger.catch "### opt::#{opt}, from::#{from}, metacheck::#{metacheck}"            
            eval("#{metacheck} = 1") unless metacheck == false
            
            from = "args[:rmsg]#{from}"
#             Dialog.logger.debug "### Metamessage - FROM #{from};\tTO: #{to}, type: #{mapType}"
            if mapType.to_s == 'opt'
              nilFunction = true
            else
              nilFunction = "nodata(args: args,from: from)"
            end
            begin
              eval("#{from}.nil? ? #{nilFunction} : #{to} = #{from}")
            rescue NoMethodError => @e
              Dialog.logger.debug "No method #{from}"  if nilFunction == true
            rescue TypeError => @e  
              Dialog.logger.error "Problems with mapping type: #{mapType}, #{tFields}->#{fFields}, may be optional?"        
              raise     
            end
            ##
          end
        end      
      end    
    
      def eval2mmsg_simplemap(eval2mmsg) # TODO doubled functionality
        map = {}
        if eval2mmsg.key?(:fFields)
          eval2mmsg[:tFields] = eval2mmsg[:fFields] unless eval2mmsg.key?(:tFields)          
          if eval2mmsg[:fFields].size == eval2mmsg[:tFields].size 
            map[:base] = {}
            i = 1
            while i <= eval2mmsg[:tFields].size  do
              map[:base][:"m#{i}".to_sym] = {from: 'f1', to: 't1'}
              i+=1
            end
          else
            Dialog.logger.error "EVAL map not equal"        
            raise
          end    
        end
        
        if eval2mmsg.key?(:fFieldsOpt)
          eval2mmsg[:tFieldsOpt] = eval2mmsg[:fFieldsOpt] unless eval2mmsg.has_key?(:tFieldsOpt)
          if eval2mmsg[:fFieldsOpt].size == eval2mmsg[:tFieldsOpt].size 
            
            map[:opt] = {}
            i = 1
            while i <= eval2mmsg[:tFieldsOpt].size  do
              map[:opt][:"m#{i}".to_sym] = {from: 'f1', to: 't1'}
              i+=1
            end
          else
            Dialog.logger.error "EVAL map not equal"        
            raise
          end
        end  
        
  #       Dialog.logger.debug "#{map}"          
        return map
      end
      
          
      
      def leaveGroup(args)
        args[:api][:op] = 'Message'          
        args[:smsg] = {}           
        args[:smsg][:chat_id] = args[:rmsg].chat.id
        args[:smsg][:text] = I18n.t('_action_group2supergroup')
        Dialog::BotApi.apiActionSend(args) 
        args[:api][:op] = 'leaveChat'                
        Dialog::BotApi.apiAction(args) 
      end    
      
      def final(args)      
          if args[:mmsg][:fqn].key?(:g)
            args[:mmsg].delete(:fqnrun)
          elsif args[:mmsg][:fqn].key?(:f)
            args[:mmsg][:fqnrun].key?(:g) ? args[:mmsg][:fqnrun].delete(:f) : nofinal(args, 'f->g')
          elsif args[:mmsg][:fqn].key?(:o)
            args[:mmsg][:fqnrun].key?(:f) ? args[:mmsg][:fqnrun].delete(:o) : nofinal(args, 'o->f')          
          elsif args[:mmsg][:fqn].key?(:c)
            args[:mmsg][:fqnrun].key?(:o) ? args[:mmsg][:fqnrun].delete(:c) : nofinal(args, 'c->o')          
          else          
            Dialog.logger.error "### FINAL GOES WRONG"
          end
          
        return args[:mmsg]
      end
      
      def nofinal(args, step)
        error = "### NO next FQN step (#{step}) for : '#{args[:mmsg]}' ###"
        Dialog.logger.error "#{error}"
        raise 'LostFQN'      
      end
            
      def  metaStep(args, method)
        method = method.split('_')[1]
        step = getStep(method)
        
        args[:mmsg][:fqn][step[:curr]] = args[:mmsg][:fqnrun][step[:curr]]
        args[:mmsg][:fqndata][step[:curr]] = {}
        args[:x][:metamess][:m] = method
      end
      
    end
  end
end
