########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########

module Dialog  
  class << self
    
  def _require_min
      ### SYSTEM
      require 'pp'
      require 'timeout'
      require 'logger'
      require 'socket'
      require 'fileutils'
      require 'open3'
      require 'date'      
      

      ### GEMS
      require 'dry-configurable'
      
      
      require_relative './version.rb'
      Dir.glob(File.join("#{File.dirname(__FILE__)}/triggers/**", "*.rb")).each{|f| require f}      
      Dir.glob(File.join("#{File.dirname(__FILE__)}/begin/**", "*.rb")).each{|f| require f}            
      require_relative './configuration.rb'
    end
    
    def _require_background
      require 'sidekiq'
      require 'sidekiq/batch'   
      require 'sidekiq/api'      
      require 'sidekiq-status'      
      require 'sidekiq-cron'
      require 'sidekiq-rate-limiter'
    end
    
    
    def _require
      ### SYSTEM
      require 'uri'
      require 'erb'
      require 'shellwords'
      require 'drb'      

      ### GEMS
      require 'active_support/time'       
      require 'dialect_lookup'
      require 'telegram/bot'
      require 'i18n'
      require 'redis'
      require 'concurrent'
      require 'oj'
      require 'sidekiq'
      require 'sidekiq/batch'                  
      require 'sidekiq-status'      
      require 'sidekiq-cron'
      require 'sidekiq-rate-limiter'
      #lazy_object

      ### DRY
      # require 'dry-monads'
      # require 'dry-matcher'
      # require 'dry-transaction'
      # require 'dry/inflector'
      # require 'dry-validation'
      # require 'dry-struct'
      # require 'dry-types'

      #dry-events - pub/sub

      ### CODE
      Dir.glob(File.join("#{File.dirname(__FILE__)}/**", "*.rb")).each{|f| require f}
    end
    
  end
end
    
