########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########

module Dialog
  module Statistics
    class << self
      
    
      def defHeaderUserOverall(args)
        return {:type    => 'UserOverall', :typeKey => args[:mmsg][:fqndata][:o][:from][:id]}
      end
      
      def pushStatUserOverall(args, push)
        run = defHeaderUserOverall(args)
        run[:key]   = push[:key]
        run[:value] = push[:value] if push.has_key?(:value)
        run[:redisOp] = push[:redisOp] if push.has_key?(:redisOp)
        Dialog::Storage::Redis.pushStat(run)
      end    
      
      
      def defHeaderPerUser(args)
        return {:type    => 'perUser', :typeKey => "#{args[:mmsg][:fqndata][:o][:from][:id]}:#{args[:mmsg][:fqndata][:o][:chat][:id]}"}
      end      
      
      def pushStatPerUser(args, push)
        run = defHeaderPerUser(args)
        run[:key]   = push[:key]
        run[:value] = push[:value] if push.has_key?(:value)
        run[:redisOp] = push[:redisOp] if push.has_key?(:redisOp)
        Dialog::Storage::Redis.pushStat(run)
      end       
      
      
      def defHeaderPerChat(args)
        return {:type    => 'perChat', :typeKey => "#{args[:mmsg][:fqndata][:o][:chat][:id]}"}
      end      
      
      def pushStatPerChat(args, push)
        run = defHeaderPerChat(args)
        run[:key]   = push[:key]
        run[:value] = push[:value] if push.has_key?(:value)
        run[:redisOp] = push[:redisOp] if push.has_key?(:redisOp)
        Dialog::Storage::Redis.pushStat(run)
      end        
      
      
      def defHeaderFQNPerUser(args)
        return {:type    => 'FQNPerUser', :typeKey => "#{args[:mmsg][:fqndata][:o][:from][:id]}:#{args[:mmsg][:fqn].map{|k,v| "#{v}"}.join('_')
}"}
      end      
      
      def pushStatFQNPerUser(args, push)
        run = defHeaderFQNPerUser(args)
        run[:key]   = push[:key]
        run[:value] = push[:value] if push.has_key?(:value)
        run[:redisOp] = push[:redisOp] if push.has_key?(:redisOp)
        Dialog::Storage::Redis.pushStat(run)
      end        
      
    end
  end
end
