########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########

module Dialog
  module Storage
    module Redis
      class << self 

      
        def typeKeyDescr(query, args)
          case query[:type]
          when 'chat'
            query[:typeKey] = args[:mmsg][:fqndata][:o][:chat][:id]
            query[:pushCache] = true if query[:key] == 'context'
          when 'user'
            query[:typeKey] = args[:mmsg][:fqndata][:o][:from][:id]
          end
        end        
        
      
        def pullCached(query, args)
          typeKeyDescr(query, args)        
          a =  redisDo({:type  => :cache, 
                        :op    => :read, 
                        :data  => {hname: "#{query[:type]}:#{query[:typeKey]}", k: query[:key]}, 
                        :query => query})        
          #[0]  # possible BUG - first array element
          
          Dialog.logger.debug "Redis Request: #{query}"      
          
          if a.nil? and query[:pushCache] == true
            a = pushCachedPreproc(query, args)
          else
            Dialog.logger.debug "Using cached query for the upper request"            
          end
        end
      
        
        def pushCachedPreproc(query, args)
          typeKeyDescr(query, args)
          Dialog.logger.debug "Redis pushToCache, typeKey::#{query[:typeKey]}, type::#{query[:type]}"        
          
          case query[:type]
          when 'chat'
            case query[:key]
            when 'context'
              res = pushCachedPreprocChatContext(query, args)
            end

          when 'user'
            case query[:key]
            when :example
              true
            end
          end
          
          return redisDo({:type  => :cache, 
                          :op    => :write, 
                          :data  => {hname: "#{query[:type]}:#{query[:typeKey]}", k: query[:key], v: res}, 
                          :query => query})
        end
        
      
      end
    end 
  end
end
