########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########

module Dialog
  module Storage
    module Redis
      class << self        
      
        def redisDo(act)
          case act[:type]
          when :cache
            redis = Dialog.redisDBCache          
          when :stat
            redis = Dialog.redisDBStat
          when :store
            redis = Dialog.redisDBStore
          end
          
          case act[:op]
          when :write
            res = redis.hmset("#{act[:data][:hname]}", ":#{act[:data][:k]}", act[:data][:v])
            act[:query].key?(:ttl) ? ttl = act[:query][:ttl] : ttl = false
            redis.expire "#{act[:data][:hname]}", act[:query][:ttl] unless ttl == false
            Dialog.logger.debug "Redis SET - #{act[:data][:hname]} K:#{act[:data][:k]} V: #{act[:data][:v]} with ttl #{ttl}"
            act[:data][:v]
          when :read
            res = redis.hmget("#{act[:query][:type]}:#{act[:query][:typeKey]}", ":#{act[:query][:key]}")[0]  # possible BUG - first array element 
          when :inc
            res = redis.hincrby("#{act[:data][:hname]}", ":#{act[:data][:k]}", 1)
          end
          
          return res
        end
        
      end
    end 
  end
end
