########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########
module Dialog  
  module TDLib
    class << self

      def tdlibInit
        name = Dialog.config.naming.instance
        FileUtils.mkdir_p("#{Dialog.config.path.dialogData}/tdlib/#{name}")        
        config = {
            api_id: Dialog.config.tdlib.id,
            api_hash: Dialog.config.tdlib.hash_s,
            device_model: Dialog.config.naming.app,
            database_directory: "#{Dialog.config.path.dialogData}/tdlib/#{name}",
            files_directory:    "#{Dialog.config.path.dialogData}/tdlib/#{name}",
          }
                
        TD.configure do |config|
          config.lib_path = '/usr/lib64'
        end
        
        TD::Api.set_log_verbosity_level(Dialog.config.log.tdlib.to_i)  
        handler = TD::Client.new(**config)
        
        return handler
      end

    end
  end
end
