########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########

module Dialog
  module BotApi
    class << self
    
      def apiActionGet(args)   
        args[:api][:op] = "get#{args[:api][:op]}"
        a = apiAction(args)
        return a
      end
      
      def apiActionSend(args)
        args[:api][:op] = "send#{args[:api][:op]}"
        a = apiAction(args)
        return a
      end    

      def apiAction(args)  
        args[:perf][:preApiAction] = Time.now        
        op = args[:api][:op]
        Dialog.logger.debug "Operation #{op}: #{args[:smsg]}\n"
        a = args[:bot].api.send("#{op}".to_sym, args[:smsg])   
        Dialog.logger.debug "API Answer - #{a}"                      
        
        args[:perf][:postApiAction] = Time.now                
        if a["ok"] == true
          return a
        else
          Dialog.logger.info "ERROR in bot.api interaction #{"#{op}".to_sym}, msg: #{args[:smsg]}"        
        end
        args[:smsg] = {}
        args[:api] = {}
        args[:x] = {}
      end     
      
      
      def socks5_connection
        require 'telegram/bot/adapters/socks5'

        host = "https://#{Dialog.config.proxy.host}:#{Dialog.config.proxy.port}"                                            
        proxy_opts = {
            uri: URI.parse(host),
            user: Dialog.config.proxy.login,
            password: Dialog.config.proxy.pass,
            socks: true
        }

          c = Faraday.new(url: Dialog.config.host.apiUri,
                                  ssl: {verify:false},
                                  request: { proxy: proxy_opts }) do |c|
            c.request :multipart
            c.request :url_encoded
            Faraday::Adapter.register_middleware socks5: Telegram::Bot::Adapters::Socks5
            c.adapter :socks5  
          end
          return c        
      end
    
    end
  end
end 
