########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########

module Dialog

  def self.logger
    @logger ||= Log.new(Dialog.config.log.base)
  end

  class Log

    def initialize(debug_level)
      @logger ||= Logger.new(STDERR)
      @logger.datetime_format = "sec: %S.%6N"            
      @logger.formatter = proc do |severity, datetime, progname, msg|
        "#{msg}\n"
      end      
       
      @debug_level = debug_level
    end

    def catch(message)
      @logger.debug "\033[33m#{message}\033[0m" if [:debug].include? @debug_level.to_sym
    end  
    
    def debug(message)
      @logger.debug "\033[32m#{message}\033[0m" if [:debug].include? @debug_level.to_sym
    end    

    def info(message)
      @logger.info "\033[36m#{message}\033[0m"  if [:info, :debug].include? @debug_level.to_sym
    end

    def warn(message)
      @logger.warn "\033[35m#{message}\033[0m"  if [:warn, :info, :debug].include? @debug_level.to_sym
    end

    def error(message)
      @logger.error "\033[31m#{message}\033[0m" if [:error, :warn, :info, :debug].include? @debug_level.to_sym
    end

  end

end
